/***************************************************************************
 *            callbacks.cc
 *
 *  Tue Feb 25 22:01:26 2003
 *  Copyright  2003  earthworm
 *  earthworm@localhost
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

// includes ///////////////////////////////////////////////////////////////////
//
#include <iostream>
#include <fstream>
#include <gnome.h>
#include <gtk/gtk.h>
#include <glade/glade.h>
#include <glib.h>
#include <time.h>
#include <stdlib.h>
#include <string>
#include <sstream>
#include <vector>
#include "config.h"
#include "../include/callbacks.h"

// DEFINES ////////////////////////////////////////////////////////////////////
//
#define  STR				str().c_str()

#define  GAME_READY			0x00000001
#define  SOUND_ON			0x00000002
#define  STROBE_SET			0x00000004
#define  COIN_GAME			0x00000008
#define  HORSE_GAME			0x00000010
#define  CARD_GAME_END		0x00000020

#define  vector_iterator	std::vector<std::string>::iterator

// GLOBALS ////////////////////////////////////////////////////////////////////
//
char *						ar_names[6];				// pointers to player names
int							n_player_index;
int							n_totalPlayers;
int	    					ar_playerTrack[6];
int							ar_playerGulps[6];
int							ar_playerFortune[6];
int							gameIndex;					// current game
int							n_time;						// used for timed gulps etc
int							n_total_time;				// dito
int							n_gulps;
int							n_guess;					// what coin?

int							n_wait_time;				// get on with it timer
std::string					sz_backup;					// back up messages on get on with it

GtkButton       			* g_button;

char 						ar_strobe[9][50];			// frames for the strobe
int							n_anim_index;

std::vector<std::string>	ar_horse;					// frames for the horse
vector_iterator				it_horse;
int							n_horse_bias1;				// guarantee a clear winner
int							n_horse_bias2;				// guarantee a clear winner

std::vector<std::string>	ar_cards;					// card images
vector_iterator				it_cards;
int							n_card1_value;
int							n_card2_value;
int							n_card_player_index = 0;

int							n_game_state = SOUND_ON;	// or in various game states

GtkTreeStore * 				gtk_tree_store = NULL;

extern GladeXML 			* xml;						// pointer for xml interface loading

// TYPEDEFS ///////////////////////////////////////////////////////////////////
//
enum
{
	STRING_COLUMN,
	INT_COLUMN,
	N_COLUMNS
};

// index game notebook pages
enum
{
	MAIN_PAGE,
	COIN_PAGE,
	HORSE_PAGE,
	GULPS_PAGE,
	CARDS_PAGE
};

// quick function - doesn't work  :)
char
itoa									(int l)
{
	char c = l+48;
	return c;
}

// CALLBACKS //////////////////////////////////////////////////////////////////
//
void
on_letsGo_click                        (GtkButton       *button,
                                        gpointer         user_data)
{
	int			i;
	
	// play sound to kick things off
  	sound_play("/ALotOfBeer.wav");
	
	// grab notebook widget
	GtkNotebook * p__notebook_widget = (GtkNotebook *)glade_xml_get_widget(xml, "gameNoteBook");

	// next tab
	gtk_notebook_next_page(p__notebook_widget);

	// grab player count
	GtkEditable * p_edit_widget = (GtkEditable *)glade_xml_get_widget(xml, "entry_numPlayers");
	 
	// grab the text
	gchar * sz_temp = gtk_editable_get_chars(p_edit_widget, 0, -1);
	
	// convert it
	n_totalPlayers = atoi(sz_temp);
	n_player_index  = 1;

	// housework
	g_free(sz_temp);

	GtkEntry * p_entry_widget;

	// get the player names
	p_entry_widget = (GtkEntry *)glade_xml_get_widget(xml, "entry_p1");
	ar_names[0]  = (char *)gtk_entry_get_text(p_entry_widget);

	p_entry_widget = (GtkEntry *)glade_xml_get_widget(xml, "entry_p2");
	ar_names[1]  = (char *)gtk_entry_get_text(p_entry_widget);

	p_entry_widget = (GtkEntry *)glade_xml_get_widget(xml, "entry_p3");
	ar_names[2]  = (char *)gtk_entry_get_text(p_entry_widget);

	p_entry_widget = (GtkEntry *)glade_xml_get_widget(xml, "entry_p4");
	ar_names[3]  = (char *)gtk_entry_get_text(p_entry_widget);

	p_entry_widget = (GtkEntry *)glade_xml_get_widget(xml, "entry_p5");
    ar_names[4]  = (char *)gtk_entry_get_text(p_entry_widget);

	p_entry_widget = (GtkEntry *)glade_xml_get_widget(xml, "entry_p6");
	ar_names[5]  = (char *)gtk_entry_get_text(p_entry_widget);

	// clear penalties & fourtune trackers
	for(i = 0; i < 6; i ++)
	{
		ar_playerTrack[i] = 0;
		ar_playerGulps[i] = 0;
		ar_playerFortune[i] = 0;
	}// end for
	
	// initialize random generator
  	srand48 ( time(NULL) );
	
	// add the cards
  	ar_cards.push_back(PACKAGE_PIXMAPS_DIR"/ace.png");
  	ar_cards.push_back(PACKAGE_PIXMAPS_DIR"/two.png");
  	ar_cards.push_back(PACKAGE_PIXMAPS_DIR"/three.png");
  	ar_cards.push_back(PACKAGE_PIXMAPS_DIR"/four.png");
  	ar_cards.push_back(PACKAGE_PIXMAPS_DIR"/five.png");
  	ar_cards.push_back(PACKAGE_PIXMAPS_DIR"/six.png");
  	ar_cards.push_back(PACKAGE_PIXMAPS_DIR"/seven.png");
  	ar_cards.push_back(PACKAGE_PIXMAPS_DIR"/eight.png");
  	ar_cards.push_back(PACKAGE_PIXMAPS_DIR"/nine.png");
  	ar_cards.push_back(PACKAGE_PIXMAPS_DIR"/ten.png");
  	ar_cards.push_back(PACKAGE_PIXMAPS_DIR"/jack.png");
  	ar_cards.push_back(PACKAGE_PIXMAPS_DIR"/queen.png");
  	ar_cards.push_back(PACKAGE_PIXMAPS_DIR"/king.png");

	// set up the penalty track tree
	GtkTreeView * p_treeView = (GtkTreeView *)glade_xml_get_widget(xml, "treeview_penalty");
	
	if(gtk_tree_store == NULL)
	{	
		// omg, nothing is ready yet!
		
		// new tree then ..
		gtk_tree_store = gtk_tree_store_new(2, G_TYPE_STRING, G_TYPE_INT);
	
		gtk_tree_view_set_model(p_treeView, (GtkTreeModel *)gtk_tree_store);
		
		// associate a renderer for the tree
		GtkCellRenderer *renderer;
		GtkTreeViewColumn *column;

		renderer = gtk_cell_renderer_text_new ();
		
		column = gtk_tree_view_column_new_with_attributes ("Player",
                                                   	   		renderer,
                                                   	   		"text", 0,
                                                   			NULL);
														
		gtk_tree_view_append_column (GTK_TREE_VIEW (p_treeView), column);
	
		column = gtk_tree_view_column_new_with_attributes ("Rounds Left",
                                                   	   	   	renderer,
                                                   	       	"text", 1,
                                                   		    NULL);
														
		gtk_tree_view_append_column (GTK_TREE_VIEW (p_treeView), column);
	}// end if
	else
	{
		gtk_tree_store_clear(gtk_tree_store);
	}// end else
	
	// add the player names to the penalty tracker
	GtkTreeIter TreeIter;
	
	for(i = 0; i < n_totalPlayers; i ++)
	{
		gtk_tree_store_append(gtk_tree_store, &TreeIter, 0);
	
		gtk_tree_store_set(gtk_tree_store, &TreeIter, STRING_COLUMN, ar_names[i], -1);
	}// end for
	
	// set get on with it to zer0
	n_wait_time = 0;
	
	// ok
	n_game_state |= GAME_READY;
}


void
on_window1_destroy                     (GtkObject       *object,
                                        gpointer         user_data)
{
	gtk_main_quit();
}


void
on_rollBtn_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	std::string			sz_temp;
	std::stringstream 	builder;

	// quick check!!
	if(n_game_state & GAME_READY)
	{
		// grab the status text widgets
		GtkWidget * p_widget_text0 = glade_xml_get_widget(xml, "statusText0");
		GtkWidget * p_widget_text1 = glade_xml_get_widget(xml, "statusText1");
		GtkWidget * p_widget_text2 = glade_xml_get_widget(xml, "statusText2");
			
		// dice has been rolled
    	sound_play("/crush.wav");
		
		// strip the live chick!!
		GtkWidget *p_widget = glade_xml_get_widget(xml, "image_stripper");
		
		gint n_strip_y, n_strip_x;
		
		gtk_widget_get_size_request(p_widget, &n_strip_y, &n_strip_x);
		gtk_widget_set_size_request(p_widget, ++n_strip_y, n_strip_x);
		
		// show who's turn
		builder << "<span size=\"large\">Player " << n_player_index << ": " << ar_names[n_player_index-1] << "</span>";
		sz_temp = builder.str();
	
		gtk_label_set_markup(GTK_LABEL(p_widget_text0), sz_temp.c_str());
	
		// show who's next
		builder.str("");
		builder << "<span size=\"large\">Next Up: " << ar_names[(n_player_index-1+n_totalPlayers+1) % n_totalPlayers] << "</span>";
		
		sz_temp = builder.str();
		
		gtk_label_set_markup(GTK_LABEL(p_widget_text2), sz_temp.c_str());
		
		// one round over?
		if(n_player_index == 1)
			penalty_tracker(-1, NULL);
	
		// most work done in here
    	drinkingGame(button, user_data);
	
		// move to next player
    	if(n_player_index < n_totalPlayers)
        	n_player_index ++;
    	else
        	n_player_index = 1;
	}// end if
	else
	{
		GtkWidget * p_widget_text1 = glade_xml_get_widget(xml, "statusText1");
	
		// show who's turn
		builder << "<span size=\"x-large\">Set up properly bone head!!</span>";
	
		gtk_label_set_markup(GTK_LABEL(p_widget_text1), builder.str().c_str());
		
		sound_play("/burp.wav");
	}// end else
}

void		
drinkingGame						   (GtkButton       *button,
                                        gpointer         user_data)
{
	bool					b_customString1,
							b_customString2,
							b_customString3;		// bool for each custom item
	std::stringstream		ssbuilder;				// build our strings
	GtkWidget				* p_widget;
	
	// grab the status text widgets
	GtkWidget * p_widget_text0 = glade_xml_get_widget(xml, "statusText0");
	GtkWidget * p_widget_text1 = glade_xml_get_widget(xml, "statusText1");
	GtkWidget * p_widget_text2 = glade_xml_get_widget(xml, "statusText2");
	
	// see if there are custom strings
	GtkWidget * p_widget_check1 = glade_xml_get_widget(xml, "checkbutton1");
	b_customString1 = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(p_widget_check1));
	
	GtkWidget * p_widget_check2 = glade_xml_get_widget(xml, "checkbutton2");
	b_customString2 = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(p_widget_check2));
	
	GtkWidget * p_widget_check3 = glade_xml_get_widget(xml, "checkbutton3");
	b_customString3 = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(p_widget_check3));
	
	// they are still playing ...
	n_wait_time = 0;
	
	// save this so the timer can work
	g_button = button;
	
	// choose a game at random
	if(b_customString1 | b_customString2 | b_customString3)
		gameIndex = lrand48() % 22;
	else
		gameIndex = lrand48() % 21;
	
	// if strobe was set, turn it off
	if(n_game_state & STROBE_SET)
	{
		// get status widget
		GtkWidget * p_widget_image = glade_xml_get_widget(xml, "image_main");
			
		// next image
		gtk_image_set_from_file(GTK_IMAGE(p_widget_image), PACKAGE_PIXMAPS_DIR"/intro.png");
		
		// kill the flag
		n_game_state ^= STROBE_SET;
	}// end if
	
	// switch to get to the game
	switch(gameIndex)
	{
		case 0:
		{
			// SIMPLE GULPS ///////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/pee.wav");
			
			// random number of gulps
          	int t = (lrand48() % 6) + 1;

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Drink " << t << " Gulps!!!!</span>";
			
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
		}// end case
		break;
		
		case 1:
		{
			// MINI GAME //////////////////////////////////////////////////////
			//
			// call set up
			mini_game();
		}// end case
		break;
		
		case 2:
		{
			// play a sound
			sound_play("/words.wav");
			
			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Start A Round Of Wizz</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
		}
		break;
		
		case 3:
		{
			// NOMINATE ///////////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/BestTasting.wav");
			
			// random number of gulps
          	int t = (lrand48() % 6) + 1;

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Nominate " << t << " Gulps To Somebody!!!!</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
		}// end case
		break;
		
		case 4:
		{
			// FILM QUIZ///////////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/abunchofquestions.wav");

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Ask a film quiz question and drink 1/2 a pint if the others get it right, if they are wrong, they have 3 gulps each.</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
		}// end case
		break;
		
		case 5:
		{
			// TEAM GAME //////////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/talktomother.wav");

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Make 2 teams, set a topic (eg items of clothing) and take it in turns to name an item in the catagory, the loosers drink 4 gulps</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
		}// end case
		break;
		
		case 6:
		{
			// OTHER HAND /////////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/Nipples.wav");

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Drink with your other hand for two rounds, penalty is 1 pint!!</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
			
			
			penalty_tracker(n_player_index,"Other Hand");
          	
			// keep track of this bad luck
			ar_playerFortune[n_player_index] ++;
		}// end case
		break;
		
		case 7:
		{
			// CAN'T LAUGH ////////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/laugh.wav");

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Do not laugh for two rounds, penalty is half a pint!</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
			
			
			penalty_tracker(n_player_index,"Can't Laugh");
          	
			// keep track of this bad luck
			ar_playerFortune[n_player_index] ++;
		}// end case
		break;
		
		case 8:
		{
			// GROUP GAME /////////////////////////////////////////////////////
			//
			// call set up
			group_game();
		}// end case
		break;
		
		case 9:
		{
			// SIMPLE GULPS ///////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/pee.wav");
			
			// random number of gulps
          	int t = (lrand48() % 6) + 1;

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Drink " << t << " Gulps!!!!</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
		}// end case
		break;
		
		case 10:
		{
			// SIMPLE GULPS ///////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/pinball.wav");
			
			// random number of gulps
          	int t = (lrand48() % 6) + 1;

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Paper scissors rock with the geezer on your left for " << t << " Gulps!!!</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
		}// end case
		break;
		
		case 11:
		{
			// SIMPLE GULPS ///////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/ballwash.wav");
			
			// random number of gulps
          	int t = (lrand48() % 6) + 1;

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Person on your right has " << t << " Gulps!!!</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
		}// end case
		break;
		
		case 12:
		{
			// SIMPLE GULPS ///////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/Alarm02.wav");
			
			// random number of gulps
          	int t = (lrand48() % 6) + 1;

			// show the player their fate
			ssbuilder <<  "<span size=\"x-large\">Last person to stand up drinks " << t << " Gulps!!!</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
			
			// set state
			n_game_state |= STROBE_SET;
		}// end case
		break;
		
		case 13:
		{
			// SIMPLE GULPS ///////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/kickmeinthejimmy.wav");
			
			// random number of gulps
          	int t = (lrand48() % 6) + 1;

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Person on your left has " << t << " Gulps!!!</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
		}// end case
		break;
		
		case 14:
		{
			// CAN'T PISS /////////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/piss.wav");

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">You cant go to the toilet for 2 rounds bitch!</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
			
			
			penalty_tracker(n_player_index,"Can't Piss :)");
          	
			// keep track of this bad luck
			ar_playerFortune[n_player_index] ++;
		}// end case
		break;
		
		case 15:
		{
			// SIMPLE GULPS ///////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/triple.wav");
			
			// random number of gulps
          	int t = (lrand48() % 6) + 1;
			
			// random letter
			char c = (lrand48() % 26) + 65;

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Name 3 film stars who have 1st names begining with \"" << c << "\" for " << t << " gulps</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
		}// end case
		break;
		
		case 16:
		{
			// SIMPLE GULPS ///////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/hurrah.wav");

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">2 gulps for everyone</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
		}// end case
		break;
		
		case 17:
		{
			// SIMPLE GULPS ///////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/jurgen.wav");

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Nominate 3 gulps to somebody, who can then nominate 2 more (to anyone but you)</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
		}// end case
		break;
		
		case 18:
		{
			// TIMED GULPS ////////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/dsnyland.wav");
			
			// get the button
			p_widget = glade_xml_get_widget(xml, "rollBtn");
			
			// break it
			gtk_widget_set_sensitive(p_widget, false);
			
			// random number of gulps
          	n_gulps = (lrand48() % 7) + 1;
			
			// random time 4 'em
			n_total_time = n_time = (lrand48() %120) + 20;
			
			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Drink " << n_gulps << " gulps in " << n_time << " seconds!!!</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
			
			// grab notebook widget
			GtkWidget * p_notebook_widget = glade_xml_get_widget(xml, "notebook_games");

			// set the tab
			gtk_notebook_set_current_page(GTK_NOTEBOOK(p_notebook_widget), GULPS_PAGE);
		}// end case
		break;
		
		case 19:
		{
			// MOVIE QUESTIONS ////////////////////////////////////////////////
			//
			FILE			* f;
			char			movieName[40];
			int				temp_int;
			std::ifstream	infile;
			
			sound_play("/fart.wav");
			
			// open the file			
			f = fopen(PACKAGE_DATA_DIR"/movies.txt", "rt");
			
			// get random film name
          	temp_int = lrand48()%141;
			
			// trap if file is missing
			if(f == NULL)
			{
				temp_int = 0;
				printf("file movies.txt not found\n");
			}// end if
			
			// switch to random game
			switch(lrand48()%3)
			{
          	case 0:
			{
				// loop to selected line number
                while(temp_int > 0)
				{
                	fgets(movieName, 40, f);
                    temp_int --;
				}// end while
				  
				// random number of gulps
          		int temp_int = (lrand48() % 6) + 1;
                
				// show the player their fate
				ssbuilder <<  "<span size=\"x-large\">Name 2 actors/charactors from the film \"" << movieName << "\" for " << temp_int << " gulps</span>";
				gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
			}// end case
			break;
			
			case 1:
			{
				// loop to selected line number
                while(temp_int > 0)
				{
                	fgets(movieName, 40, f);
                    temp_int --;
				}// end while
				  
				// random number of gulps
          		int temp_int = (lrand48() % 6) + 1;
                
				// show the player their fate
				ssbuilder << "<span size=\"x-large\">Link the film \"" << movieName << "\" to Arnold Schwarzenegger for " << temp_int << " gulps</span>";
				gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
			}// end case
			break;
			
			case 2:
			{
				// loop to selected line number
                while(temp_int > 0)
				{
                	fgets(movieName, 40, f);
                    temp_int --;
				}// end while
				  
				// random number of gulps
          		int temp_int = (lrand48() % 6) + 1;
                
				// show the player their fate
				ssbuilder << "<span size=\"x-large\">Name a star from the film \"" << movieName << "\" for " << temp_int << " gulps</span>";
				gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
			}// end case
			break;
			}// end switch
			  
			// close the file
        	if(f != NULL)
				fclose(f);
		}// end case
		break;
		
		case 20:
		{
			// SPORTS NAME ////////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/makeLove.wav");
			
			// random number of gulps
          	int t = (lrand48() % 6) + 1;
			
			// random letter
			char c = (lrand48() % 26) + 65;

			// show the player their fate
			ssbuilder << "<span size=\"x-large\">Name 3 sports stars who have 1st names begining with \"" << c << "\" for " << t << " gulps</span>";
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
		}// end case
		break;
		
		case 21:
		{
			// CUSTOM STRINGS /////////////////////////////////////////////////
			//
			const gchar		* ar_strings[3];
			int				n_strings = 0;
			
			// play a sound
			sound_play("/dsnyland.wav");
			
			// add any strings to the array
			if(b_customString1)
			{
				// grab the entry widget
				p_widget = glade_xml_get_widget(xml, "entry_string1");
				
				// get the text from it
				ar_strings[n_strings]  = gtk_entry_get_text(GTK_ENTRY(p_widget));
				
				// inc count
				n_strings ++;
			}// end if
			
			if(b_customString2)
			{
				// grab the entry widget
				p_widget = glade_xml_get_widget(xml, "entry_string2");
				
				// get the text from it
				ar_strings[n_strings]  = gtk_entry_get_text(GTK_ENTRY(p_widget));
				
				// inc count
				n_strings ++;
			}// end if
			
			if(b_customString3)
			{
				// grab the entry widget
				p_widget = glade_xml_get_widget(xml, "entry_string3");
				
				// get the text from it
				ar_strings[n_strings]  = gtk_entry_get_text(GTK_ENTRY(p_widget));
				
				// inc count
				n_strings ++;
			}// end if
			
			ssbuilder << "<span size=\"x-large\">" << ar_strings[lrand48()%n_strings] << "</span>";
			
			// now set one of the as the players fate
			gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
		}
		break;
	}// end switch
}

// sound_play /////////////////////////////////////////////////////////////////
//
// play a sound if the sound is enabled
void
sound_play								(char * sz_path)
{
	std::stringstream		ssbuilder;				// build our strings
	
	ssbuilder << PACKAGE_DATA_DIR << sz_path;
	
	if(n_game_state & SOUND_ON)
	{
		#ifdef linux
			gnome_sound_play(ssbuilder.STR);
		#endif
		#ifdef WIN32
			PlaySound(ssbuilder.STR, 0, SND_FILENAME | SND_ASYNC);
		#endif
	}// end if 
}// end sound_play

// penalty_tracker ////////////////////////////////////////////////////////////
//
// dual purpose, updates the tracker with new items
// and manages existing ones when called with player -1
void
penalty_tracker							(int n_player_index,
										 char * sz_penalty)
{
	GtkTreeIter it1, it2;
	int			i;
	
	if(n_player_index == -1)
	{
		//printf("%i\n", n_totalPlayers);
		
		for(i = 0; i < n_totalPlayers; i ++)
		{
			//GValue 			value {0, };
			int					value;
			
			// grab the players entry
			gtk_tree_model_iter_nth_child ((GtkTreeModel *)gtk_tree_store, &it1, NULL, i);
			
			// they got kids yet?
			if(gtk_tree_model_iter_has_child((GtkTreeModel *)gtk_tree_store, &it1))
			{
				// grab the players penalty
				gtk_tree_model_iter_nth_child ((GtkTreeModel *)gtk_tree_store, &it2, &it1, 0);
				
				// get current count
				gtk_tree_model_get(GTK_TREE_MODEL(gtk_tree_store), 
									&it2, 
									INT_COLUMN, &value, 
									-1);
				
				// one less turn to survive with this penalty
				value --;
				
				// maybe the last turn?
				if(!value)
				{
					// if so, get rid of penalty, phew
					gtk_tree_store_remove(gtk_tree_store, &it2);
				}// end if
				else
				{
					// overwrite/set new penalty
					gtk_tree_store_set(gtk_tree_store,
										&it2, 
										INT_COLUMN, value, 
										-1);
				}// end else
			}// end if
		}// end for
	}// end if
	else
	{
		// grab the players entry
		gtk_tree_model_iter_nth_child ((GtkTreeModel *)gtk_tree_store, &it1, NULL, n_player_index-1);
	
		// they got kids yet?
		if(!gtk_tree_model_iter_has_child((GtkTreeModel *)gtk_tree_store, &it1))
			gtk_tree_store_append(gtk_tree_store, &it2, &it1);
		else
			gtk_tree_model_iter_nth_child ((GtkTreeModel *)gtk_tree_store, &it2, &it1, 0);
	
		// overwrite/set new penalty
		gtk_tree_store_set(gtk_tree_store, &it2, 
							STRING_COLUMN, sz_penalty, 
							INT_COLUMN, 2, 
							-1);
	}// end else
}// end penalty_tracker


void
on_sound_on_radiobutton_toggled        (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	n_game_state |= SOUND_ON;
}


void
on_sound_off_radiobutton_toggled       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	n_game_state ^= SOUND_ON;
}


void
drinking_game_init                     (GtkWidget       *widget,
                                        gpointer         user_data)
{
	// saftey net for timers 
	gameIndex = -1;
	
	// set some timers
	g_timeout_add(1000, on_timer1, NULL);
	g_timeout_add(250,  on_timer2, NULL);
	
	// load strobe animation frames
	strcpy(ar_strobe[0], PACKAGE_PIXMAPS_DIR"/strobe1.png");
	strcpy(ar_strobe[1], PACKAGE_PIXMAPS_DIR"/strobe2.png");
	strcpy(ar_strobe[2], PACKAGE_PIXMAPS_DIR"/strobe3.png");
	strcpy(ar_strobe[3], PACKAGE_PIXMAPS_DIR"/strobe4.png");
	strcpy(ar_strobe[4], PACKAGE_PIXMAPS_DIR"/strobe5.png");
	strcpy(ar_strobe[5], PACKAGE_PIXMAPS_DIR"/strobe6.png");
	strcpy(ar_strobe[6], PACKAGE_PIXMAPS_DIR"/strobe7.png");
	strcpy(ar_strobe[7], PACKAGE_PIXMAPS_DIR"/strobe8.png");
	strcpy(ar_strobe[8], PACKAGE_PIXMAPS_DIR"/strobe9.png");
	
	// set up strings for horse anim frames
	ar_horse.push_back(PACKAGE_PIXMAPS_DIR"/racehorse1_01.png");
	ar_horse.push_back(PACKAGE_PIXMAPS_DIR"/racehorse1_02.png");
	ar_horse.push_back(PACKAGE_PIXMAPS_DIR"/racehorse1_03.png");
	ar_horse.push_back(PACKAGE_PIXMAPS_DIR"/racehorse1_04.png");
	ar_horse.push_back(PACKAGE_PIXMAPS_DIR"/racehorse1_05.png");
	ar_horse.push_back(PACKAGE_PIXMAPS_DIR"/racehorse1_06.png");
	ar_horse.push_back(PACKAGE_PIXMAPS_DIR"/racehorse1_07.png");
	ar_horse.push_back(PACKAGE_PIXMAPS_DIR"/racehorse1_08.png");
	ar_horse.push_back(PACKAGE_PIXMAPS_DIR"/racehorse1_09.png");
	ar_horse.push_back(PACKAGE_PIXMAPS_DIR"/racehorse1_10.png");
	ar_horse.push_back(PACKAGE_PIXMAPS_DIR"/racehorse1_11.png");
	
	// set iterator
	it_horse = ar_horse.begin();
}

gboolean
on_timer1 								(gpointer data)
{
	std::stringstream		ssbuilder;
	
	// depending on the game, something might need to be done
	switch(gameIndex)
	{
		case 18:
		{
			// TIMED GULPS ////////////////////////////////////////////////////
			//
			// get status widget
			GtkWidget * p_widget_text1 = glade_xml_get_widget(xml, "statusText1");
			
			if(n_time > 0)
			{
				// play a sound
				sound_play("/click.wav");
				
				// less time
				n_time --;
				
				// get status widget
				GtkWidget * p_widget_prog = glade_xml_get_widget(xml, "progressbar_gulps");
				
				// advance progress bar
				gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(p_widget_prog), (gdouble)n_time / (gdouble)n_total_time);
				
				// show the player their fate
				ssbuilder << "<span size=\"x-large\">Drink " << n_gulps << " gulps in " << n_time << " seconds!!!</span>";
				gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.STR);
			}// end if
			else
			{
				// get the button
				GtkWidget * p_widget_button = glade_xml_get_widget(xml, "rollBtn");
			
				// fix it
				gtk_widget_set_sensitive(p_widget_button, true);
				
				// grab notebook widget
				GtkWidget * p_notebook_widget = glade_xml_get_widget(xml, "notebook_games");

				// next tab
				gtk_notebook_set_current_page(GTK_NOTEBOOK(p_notebook_widget), MAIN_PAGE);
			}// end else
		}// end case
		break;
		
		case 1:
		{
			// COIN GAME //////////////////////////////////////////////////////
			//
			if(n_game_state & COIN_GAME)
			{
				// get status widget
				GtkWidget * p_widget_text1 = glade_xml_get_widget(xml, "statusText1");
				
				// get image widget
				GtkWidget * p_widget_image = glade_xml_get_widget(xml, "image_coin");
			
				// play a sound
				sound_play("/clocktick2.wav");
				
				// swap the images on each second
				// leave it after 0 seconds for pause
				if(n_time % 2 && n_time > 0)
				{
					// next image
					gtk_image_set_from_file(GTK_IMAGE(p_widget_image), PACKAGE_PIXMAPS_DIR"/tails.png");
				}// end if
				else if(n_time > 0)
				{
					// next image
					gtk_image_set_from_file(GTK_IMAGE(p_widget_image), PACKAGE_PIXMAPS_DIR"/heads.png");
				}// end else
				
				// dec time
				n_time --;
				
				// if we are done, put everything back
				if(n_time <= -4)
				{
					// grab notebook widget
					GtkWidget * p_notebook_widget = glade_xml_get_widget(xml, "notebook_games");

					// next tab
					gtk_notebook_set_current_page(GTK_NOTEBOOK(p_notebook_widget), MAIN_PAGE);
					
					// reset image
					gtk_image_set_from_file(GTK_IMAGE(p_widget_image), PACKAGE_PIXMAPS_DIR"/heads.png");
					
					// check their guess
					if(n_guess == 0)
					{				
						// HEADS
						// grab the entry widget
						GtkWidget * p_entry_guess = glade_xml_get_widget(xml, "entry_coin");
				
						// get the text from it
						if(strcmp("heads", gtk_entry_get_text(GTK_ENTRY(p_entry_guess))) == 0)							
						{
							ssbuilder << "<span size=\"xx-large\">it was heads, nice one</span>";
						}// end if
						else
						{
							ssbuilder << "<span size=\"xx-large\">it was heads! you'd better drink 4 gulps!</span>";
						}// end else
					}// end if
					else
					{
						// TAILS
						// grab the entry widget
						GtkWidget * p_entry_guess = glade_xml_get_widget(xml, "entry_coin");


						// get the text from it
						if(strcmp("tails", gtk_entry_get_text(GTK_ENTRY(p_entry_guess))) == 0)							
						{
							ssbuilder << "<span size=\"x-large\">it was tails, nice one</span>";
						}// end if
						else
						{
							ssbuilder << "<span size=\"x-large\">it was tails! you'd better drink 4 gulps!</span>";
						}// end else
					}// end else
					
					gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.str().c_str());
					
					// get the button
					GtkWidget * p_widget_button = glade_xml_get_widget(xml, "rollBtn");
			
					// fix it
					gtk_widget_set_sensitive(p_widget_button, true);
					
					// kill the flag
					n_game_state ^= COIN_GAME;
				}// end if 
			}// end if
		}// end case
		break;
	}
	
	// GET ON WITH IT /////////////////////////////////////////////////////////
	//
	// waiting long?
	if(n_wait_time == 100)
	{
		// hurry 'em up 
		sound_play("/getOn.WAV");
		
		// get status text widget 
		GtkWidget * p_widget_text1 = glade_xml_get_widget(xml, "statusText1");
		
		// save the message there
		sz_backup = gtk_label_get_text(GTK_LABEL(p_widget_text1));
		
		// tell em to hurry up
		gtk_label_set_markup(GTK_LABEL(p_widget_text1), "<span size=\"x-large\">get on with it!!!</span>");
		
		// move on, nothing to see here
		n_wait_time ++;
	}// end if
	else
	{
		n_wait_time ++;
	}// end else
	
	// put old text back after get on with it
	if(n_wait_time > 110)
	{
		// now reset the time
		n_wait_time = 0;
		
		// get status text widget 
		GtkWidget * p_widget_text1 = glade_xml_get_widget(xml, "statusText1");
		
		// and put the old message back
		gtk_label_set_markup(GTK_LABEL(p_widget_text1), sz_backup.c_str());
	}// end if 
	
	// CARD GAME //////////////////////////////////////////////////////////////
	//
	if(n_game_state & CARD_GAME_END)
	{
		if(n_time)
		{
			n_time --;
		}// end if
		else
		{
			// grab notebook widget
			GtkWidget * p_notebook_widget = glade_xml_get_widget(xml, "notebook_games");

			// next tab
			gtk_notebook_set_current_page(GTK_NOTEBOOK(p_notebook_widget), MAIN_PAGE);
		
			// get the button
			GtkWidget * p_widget_button = glade_xml_get_widget(xml, "rollBtn");
			
			// fix it
			gtk_widget_set_sensitive(p_widget_button, true);
			
			// kill the flag
			n_game_state ^= CARD_GAME_END;
		}// end else
	}// end if
	
	// pass back ok
	return true;
}

gboolean
on_timer2 								(gpointer data)
{
	std::stringstream		ssbuilder;			// might need some string building
	
	// depending on the game, something might need to be done
	switch(gameIndex)
	{
		case 12:
		{
			// get image widget
			GtkWidget * p_widget_image = glade_xml_get_widget(xml, "image_main");
			
			// next image
			gtk_image_set_from_file(GTK_IMAGE(p_widget_image), ar_strobe[n_anim_index]);
			
			// set for next time
			n_anim_index = (n_anim_index + 1) % 9;
		}// end case
		break;
		
		case 8:
		{
			// HORSE_GAME /////////////////////////////////////////////////////
			//
			if(n_game_state & HORSE_GAME)
			{
				gfloat				f_x1, f_y1, f_x2, f_y2;		// x y pos of horses
				
				// get status widget
				GtkWidget * p_widget_text1 = glade_xml_get_widget(xml, "statusText1");
				
				// get image widgets
				GtkWidget * p_widget_image1 = glade_xml_get_widget(xml, "image_horse_1");
				GtkWidget * p_widget_image2 = glade_xml_get_widget(xml, "image_horse_2");
			
				// where are the horses?
				gtk_misc_get_alignment(GTK_MISC(p_widget_image1), &f_x1, &f_y1);
				gtk_misc_get_alignment(GTK_MISC(p_widget_image2), &f_x2, &f_y2);
				
				// next frame 
				it_horse ++;
				
				// handle vector wrap 
				if(it_horse == ar_horse.end())
				{
					// last frame, wrap 
					it_horse = ar_horse.begin(); 
				}// end if
				
				// swap the images on each second
				gtk_image_set_from_file(GTK_IMAGE(p_widget_image1), it_horse->c_str());
				gtk_image_set_from_file(GTK_IMAGE(p_widget_image2), it_horse->c_str());
				
				// get some random speed for the horses
				f_x1 += drand48()/n_horse_bias1;
				f_x2 += drand48()/n_horse_bias2;
				
				// move the horses
				gtk_misc_set_alignment(GTK_MISC(p_widget_image1), (f_x1), f_y1);
				gtk_misc_set_alignment(GTK_MISC(p_widget_image2), (f_x2), f_y2);
				
				// sort out the audio
				if(n_time == 13)
				{
					// play a sound (every 3 seconds)
					sound_play("/gallop.wav");
					
					// reset count
					n_time = 0;
				}// end if
				else
				{
					n_time ++;
				}// end else
				
				// winner yet?
				if(f_x1 >= 1.0 || f_x2 >= 1.0)
				{
					// grab notebook widget
					GtkWidget * p_notebook_widget = glade_xml_get_widget(xml, "notebook_games");

					// next tab
					gtk_notebook_set_current_page(GTK_NOTEBOOK(p_notebook_widget), MAIN_PAGE);
					

					// play a sound
					sound_play("/looser.wav");
					
					// name the winner
					if(f_x1 > f_x2)
						ssbuilder << "<span size=\"x-large\">horse A wins, loosers drink some beer</span>";
					else
						ssbuilder << "<span size=\"x-large\">horse B wins, loosers drink some beer</span>";
					
					// show the result
					gtk_label_set_markup(GTK_LABEL(p_widget_text1), ssbuilder.str().c_str());
					
					// get the button
					GtkWidget * p_widget_button = glade_xml_get_widget(xml, "button_horse_start");
			
					// fix it
					gtk_widget_set_sensitive(p_widget_button, true);
					
					// get the button
					p_widget_button = glade_xml_get_widget(xml, "rollBtn");
			
					// fix it
					gtk_widget_set_sensitive(p_widget_button, true);
					
					// move the horses back
					gtk_misc_set_alignment(GTK_MISC(p_widget_image1), 0.0, f_y1);
					gtk_misc_set_alignment(GTK_MISC(p_widget_image2), 0.0, f_y2);
					
					// reset time count
					n_time = 0;
					
					// kill the flag
					n_game_state ^= HORSE_GAME;
				}// end if 
			}// end if
		}// end case
		break;
	}// end switch
	return true;
}

void
mini_game								(void)
{
	int							i;
	std::stringstream			builder;
	
	// grab the status text
	GtkWidget * p_widget_text1 = glade_xml_get_widget(xml, "statusText1");

	// tell the players			
	builder << "<span size=\"xx-large\">Mini Game!!!!!</span>";
	
	gtk_label_set_markup(GTK_LABEL(p_widget_text1), builder.str().c_str());
	
	// get the button
	GtkWidget * p_widget_button = glade_xml_get_widget(xml, "rollBtn");
			
	// kill it
	gtk_widget_set_sensitive(p_widget_button, false);
	
	// pick a game
	switch(lrand48() % 2)
	{
		case 0:
		{
			// play a sound
			sound_play("/BarnBlch.wav");
			
			// grab notebook widget
			GtkWidget * p_notebook_widget = glade_xml_get_widget(xml, "notebook_games");

			// next tab
			gtk_notebook_set_current_page(GTK_NOTEBOOK(p_notebook_widget), COIN_PAGE);
		}// end case
		break;

		case 1:
		{
			// TODO: darts
			// play a sound
			sound_play("/BarnBlch.wav");
			
			// grab notebook widget
			GtkWidget * p_notebook_widget = glade_xml_get_widget(xml, "notebook_games");

			// next tab
			gtk_notebook_set_current_page(GTK_NOTEBOOK(p_notebook_widget), COIN_PAGE);
		}// end case
		break;
	}// end switch
}// end mini_game

void
group_game								(void)
{
	int							i;
	std::stringstream			builder;
	
	// grab the status text
	GtkWidget * p_widget_text1 = glade_xml_get_widget(xml, "statusText1");

	// tell the players			
	builder << "<span size=\"xx-large\">Group Game!!!!!</span>";
	
	gtk_label_set_markup(GTK_LABEL(p_widget_text1), builder.str().c_str());
	
	// get the button
	GtkWidget * p_widget_button = glade_xml_get_widget(xml, "rollBtn");
			
	// kill it
	gtk_widget_set_sensitive(p_widget_button, false);
	
	// pick a game
	switch(lrand48() % 2)
	{
		case 0:
		{
			// HORSE RACE /////////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/BeenDrinking.wav");
			
			// grab notebook widget
			GtkWidget * p_notebook_widget = glade_xml_get_widget(xml, "notebook_games");

			// next tab
			gtk_notebook_set_current_page(GTK_NOTEBOOK(p_notebook_widget), HORSE_PAGE);
		}// end case
		break;

		case 1:
		{
			// CARDS //////////////////////////////////////////////////////////
			//
			// play a sound
			sound_play("/HighSociety.wav");
			
			// grab notebook widget
			GtkWidget * p_notebook_widget = glade_xml_get_widget(xml, "notebook_games");

			// next tab
			gtk_notebook_set_current_page(GTK_NOTEBOOK(p_notebook_widget), CARDS_PAGE);
			
			sound_play("/chinese.wav");
		}// end case
		break;
	}// end switch
}// end group_game

void
on_button_coin_start_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
	// set game state
	n_game_state |= COIN_GAME;
	
	// random time between 5 and 15 seconds
	n_time = (lrand48() % 10) + 5;
	
	// set a flag to indicate which coin we end up with
	n_guess = n_time % 2;
}


void
on_button_horse_start_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
	// set game state
	n_game_state |= HORSE_GAME;
	
	// get the horse button
	GtkWidget * p_widget_button = glade_xml_get_widget(xml, "button_horse_start");
			
	// kill it
	gtk_widget_set_sensitive(p_widget_button, false);
	
	// set the bias on movement
	n_horse_bias1 = 30 + lrand48()%30;
	n_horse_bias2 = 30 + lrand48()%30;
	
	// play a sound
	sound_play("/gallop.wav");
	
	// set time count
	n_time = 0;
}


void
on_button_cards_play_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
	std::stringstream			builder;
	
	// get status widget
	GtkWidget * p_widget_text1 = glade_xml_get_widget(xml, "label_cards_player");
	
	// who's up next?
	builder << "<span size=\"large\">Player: " << ar_names[n_card_player_index] << "</span>";
	
	// tell 'em
	gtk_label_set_markup(GTK_LABEL(p_widget_text1), builder.STR);
	
	// get combo entry widget
	GtkWidget * p_widget_text2 = glade_xml_get_widget(xml, "combo_entry1");
	
	gtk_entry_set_text(GTK_ENTRY(p_widget_text2), "");
				
	// get image widgets
	GtkWidget * p_widget_image1 = glade_xml_get_widget(xml, "image_card1");
	GtkWidget * p_widget_image2 = glade_xml_get_widget(xml, "image_card2");		
	
	// get random 1st card
	n_card1_value = lrand48()%13;
				
	// set the card images
	gtk_image_set_from_file(GTK_IMAGE(p_widget_image1), ar_cards[n_card1_value].c_str());
	gtk_image_set_from_file(GTK_IMAGE(p_widget_image2), PACKAGE_PIXMAPS_DIR"/back.png");
	
	// get the cards button
	GtkWidget * p_widget_button = glade_xml_get_widget(xml, "button_cards_play");
			
	// kill it
	gtk_widget_set_sensitive(p_widget_button, false);
	
	// get the selection box
	GtkWidget * p_widget_combo = glade_xml_get_widget(xml, "combo_cards");
			
	// repair it
	gtk_widget_set_sensitive(p_widget_combo, true);
}

void
on_combo_entry1_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
	// get combo entry widget
	GtkWidget * p_widget_text3 = glade_xml_get_widget(xml, "combo_entry1");
	
	// skip if button press just cleared the text
	if(strcmp(gtk_entry_get_text(GTK_ENTRY(p_widget_text3)), "") != 0)
	{
	// play a sound
	sound_play("/click.wav");
	
	// get player label widget
	GtkWidget * p_widget_text1 = glade_xml_get_widget(xml, "label_cards_player");
	
	// grab the status text
	GtkWidget * p_widget_text2 = glade_xml_get_widget(xml, "statusText1");
				
	// get image widget
	GtkWidget * p_widget_image2 = glade_xml_get_widget(xml, "image_card2");
	
	// get random 2nd card
	n_card2_value = lrand48()%13;
				
	// set the card images
	gtk_image_set_from_file(GTK_IMAGE(p_widget_image2), ar_cards[n_card2_value].c_str());
	
	// get the cards button
	GtkWidget * p_widget_button = glade_xml_get_widget(xml, "button_cards_play");
			
	// repair it
	gtk_widget_set_sensitive(p_widget_button, true);
	
	// get the selection box
	GtkWidget * p_widget_combo = glade_xml_get_widget(xml, "combo_cards");
			
	// kill it
	gtk_widget_set_sensitive(p_widget_combo, false);
	
	// answer
	bool b_correct = false;
	
	// check the answer
	if(n_card2_value > n_card1_value)
	{
		b_correct = (strcmp(gtk_entry_get_text(GTK_ENTRY(p_widget_text3)), "higher") == 0);
	}// end if
	else
	{
		b_correct = (strcmp(gtk_entry_get_text(GTK_ENTRY(p_widget_text3)), "lower") == 0);
	}// end else
		
	// they get it right?
	if(!b_correct)
	{
		std::stringstream			builder;
		
		// play a sound
		sound_play("/saveloy.wav");
		
		// random number of gulps
        int t = (lrand48() % 6) + 1;
		
		// show the player their fate
		builder <<  "<span size=\"x-large\">Oops, player " << ar_names[n_card_player_index] << " have " << t << " Gulps!!!</span>";
		
		gtk_label_set_markup(GTK_LABEL(p_widget_text2), builder.STR);
		
		// set state for timer to pick up
		n_game_state |= CARD_GAME_END;
		
		// set time
		n_time = 3;
	}// end if
	
	// ready for next
	n_card_player_index = (n_card_player_index + 1) % n_totalPlayers;
	
	}// end if
}
